#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <stdlib.h>

const int MAX = 5;

struct queue
{
	int num;
	struct queue *next;
};


void init_queue (struct queue** que)
{
	*que = NULL;
}

void append (struct queue** que, int num)
{
	static struct queue* last;
	static struct queue* n_last;


	n_last = (struct queue*)malloc(sizeof(struct queue));
	n_last->num = num;
	n_last->next =NULL;

	if (*que == NULL)
		*que = n_last;
	else
		last->next = n_last;
	last = n_last;
}

void build_queue (struct queue** que)
{
	int i, num;

	printf ("\nThe number by their insertion order are:\n");
	for (i = 0; i < MAX; i++)
	{
		num = random(10);
		append (que, num);
	}
}

void display_queue (struct queue* que)
{
	struct queue* temp = que;

	printf ("\nThe members of the queue are: \n\n");

	while (temp != NULL)
	{
		printf ("  %d  ", temp->num);
		temp = temp->next;
	}

	temp = que;
	printf("\n");
	while (temp != NULL)
	{
		printf ("%p ", temp);
		temp = temp->next;
	}
}


void delete_queue (struct queue** que)
{
	struct queue *temp;

	printf("\n\nDeleting the queue:\n");
	while (*que)
	{
		printf ("%p\t", *que);
		temp = *que;
		*que = (*que)->next;
		free(temp);
	
	}
}

void main()
{
	struct queue* que;
	randomize();

	init_queue (&que);
	build_queue (&que);
	display_queue (que);
	delete_queue (&que);
}